/*
 * The Relaxer artifact
 * Copyright (c) 2000-2004, ASAMI Tomoharu, All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer. 
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
package com.netpotlet.jetty;

/**
 * @version compact-keyboard.rng 1.0 (Sun Feb 29 22:05:37 JST 2004)
 * @author  Relaxer 1.1b (http://www.relaxer.org)
 */
public interface IRVisitor {
    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(Keyboard visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(Keyboard visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(KeyboardDisplay visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(KeyboardDisplay visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(Position visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(Position visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(KeyboardKey visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(KeyboardKey visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(SizeSize1 visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(SizeSize1 visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(Label visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(Label visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(LabelType1 visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(LabelType1 visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(SizeSize2 visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(SizeSize2 visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(LabelType2 visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(LabelType2 visitable);

    /**
     * Visits this node for enter behavior.
     *
     * @param visitable
     * @return boolean
     */
    boolean enter(RString visitable);

    /**
     * Visits this node for leave behavior.
     *
     * @param visitable
     */
    void leave(RString visitable);
}
