package com.netpotlet.test;

import java.util.Stack;

import com.netpotlet.jetty.ILabelMixed;
import com.netpotlet.jetty.Keyboard;
import com.netpotlet.jetty.KeyboardDisplay;
import com.netpotlet.jetty.KeyboardKey;
import com.netpotlet.jetty.Label;
import com.netpotlet.jetty.LabelType1;
import com.netpotlet.jetty.LabelType2;
import com.netpotlet.jetty.RVisitorBase;

public class KeyboardAssembler extends RVisitorBase {
    private Stack stack = new Stack();
    private MyKeyboard myKeyboard = null;
    
    MyKeyboard getMyKeyboard() {
        return myKeyboard;
    }

    public boolean enter(Keyboard visitable) {
        myKeyboard= new MyKeyboard(visitable);
        stack.push(myKeyboard);
        return (true);
    }

    public void leave(Keyboard visitable) {
    }

    public boolean enter(KeyboardDisplay visitable) {
        if (!stack.empty()) {
            MyKeyboard myKeyboard = (MyKeyboard)stack.peek();
            MyDisplay myDisplay = 
              new MyDisplay(visitable, myKeyboard);
            stack.push(myDisplay);
        }
        return (true);
    }

    public void leave(KeyboardDisplay visitable) {
        stack.pop();
    }

    public boolean enter(KeyboardKey visitable) {
        MyKeyboard myKeyboard = (MyKeyboard)stack.peek();
        Label label = visitable.getLabel(0);
        ILabelMixed[] mixedLabels = label.getContent();
        for (int i=0; i<mixedLabels.length; i++) {
            ILabelMixed labelMixed = mixedLabels[i];
            if ((labelMixed instanceof LabelType1) ||
                (labelMixed instanceof LabelType2)) {
                String type = labelMixed.getContentAsString();
                if ("control".equals(type)) {
                    MyControlKey myControlKey = 
                        new MyControlKey(visitable, myKeyboard);
                    return (false);
                }
            }
        }
        MyCharacterKey myCharacterKey = 
          new MyCharacterKey(visitable, myKeyboard);
        return (false);
    }

    public void leave(KeyboardKey visitable) {
    }
}
