package com.netpotlet.test;

import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.Label;
import java.awt.Panel;

import com.netpotlet.jetty.KeyboardDisplay;

class MyDisplay extends Panel {
    private Label[] inputs = new Label[10];
    private Button previous = null;
    private int cursor = -1;

    MyDisplay(KeyboardDisplay display, MyKeyboard myKeyboard) {
        setLayout(new FlowLayout(FlowLayout.LEFT));
        for (int i=0; i<inputs.length; i++) {
            inputs[i] = new Label("");
            add(inputs[i]);
        }
        myKeyboard.setDisplay(this);
        myKeyboard.add(this, "North");
    }
    
    Label[] getInputs() {
        return inputs;
    }
    
    void setText(Button button) {
        if ((previous == null) || (previous != button)) {
            previous = button;
            moveCursor();
        }
        inputs[cursor].setText(button.getLabel());
    }

    void moveCursor() {
        if (cursor < (inputs.length-1)) {
            cursor++;
        } else {
            cursor = 0;
        }
    }
}
